//------------------------------------------------------------------------------
// GPL LISENCE (short)
//------------------------------------------------------------------------------
/*
 * Copyright (c) 2014 R1KO

 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 * ChangeLog:
		1.0.0 -	Релиз
*/
#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <vip_core>

public Plugin:myinfo =
{
	name = "[VIP] Defuser",
	author = "R1KO (skype: vova.andrienko1)",
	version = "1.0.0"
};

#define VIP_DEFUSER	"Defuser"

new m_bHasDefuser = -1;

public VIP_OnVIPLoaded()
{
	VIP_RegisterFeature(VIP_DEFUSER, BOOL);

	VIP_HookClientSpawn(OnPlayerSpawn);
}

public OnPluginStart()
{
	m_bHasDefuser = UTIL_FindSendPropOffs("CCSPlayer", "m_bHasDefuser");
}

UTIL_FindSendPropOffs(const String:sNetClass[], const String:sPropertyName[])
{
	new iOffset = FindSendPropOffs(sNetClass, sPropertyName);
	if (iOffset == -1) SetFailState("Fatal Error: Unable to find offset: \"%s::%s\"", sNetClass, sPropertyName);
	return iOffset;
}

public OnPlayerSpawn(iClient, iTeam, bool:bIsVIP)
{
	if(bIsVIP && iTeam == 3 && VIP_IsClientFeatureUse(iClient, VIP_DEFUSER))
	{
		if (GetEntData(iClient, m_bHasDefuser) != 1)
		{
			SetEntData(iClient, m_bHasDefuser, 1);
		}
	}
}